#INCLUDE "ac_base.h"

*************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_ac_base",lcCollate)


***********************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

loSettings.oPI=m.loPI
loInterface=CREATEOBJECT("_frm_sc",@loSettings)

*******************************************************
DEFINE CLASS _ac_base AS _pdm_PlugIn && 
   Name="_ac_base"

   ID=4000         && ID of Plug-in
   Type="AC" && Typ of plug-in (group)

   Setting=.NULL.
   Par=.NULL.
   HHC=""

   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath


      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\ac_"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         llEn=.F.
         SELE (This.ALTab)
         SET ORDER TO "I01"
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "After Create - Base plugin")

         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_msgRunFXPFailed, "Cann't run code.")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_msgCompilePRGFailed, "Cann't compile code.")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_msgCreatePRGFailed, "Cann't create code.")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, [Ukzkov plug-in pro skupinu "Po vytvoen". Tento typ plug-inu se d pout pro koprovn nebo komprimaci vytvoench soubor i penosu na jin media.])

         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC



   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,loPDM,lcFile,luCatch, lcPom,lii,lcMessage

      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)

      IF VAL(m.loPDMs.VFPVers)>=7
         luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         =EXECSCRIPT(loSetting.SourceCode)
         IF m.loPDMs.nErr#0
            lcMessage=m.This.GetString(PI_msgRunFXPFailed)
         ENDIF
         m.loPDMs.SetCatch(luCatch) && Zru zachycen chyby
      ELSE
         * Copy source code to temporaly file
         lcFile=GetTempPathEx()+"PDM_"+SYS(2015)
         luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         =STRTOFILE(loSetting.SourceCode,lcFile+".prg")
         IF m.loPDMs.nErr=0
            * compile temp. file
            COMPILE (lcFile+".prg")
            IF m.loPDMs.nErr=0
               * run temp. file
               DO (lcFile+".fxp")
               IF m.loPDMs.nErr#0
                  lcMessage=m.This.GetString(PI_msgRunFXPFailed)
               ENDIF
            ELSE
               lcMessage=m.This.GetString(PI_msgCompilePRGFailed)
            ENDIF
         ELSE
            lcMessage=m.This.GetString(PI_msgCreatePRGFailed)
         ENDIF
         IF FILE(lcFile+".prg")
            DELE FILE (lcFile+".prg")
         ENDIF
         IF FILE(lcFile+".fxp")
            DELE FILE (lcFile+".fxp")
         ENDIF
         m.loPDMs.SetCatch(luCatch) && Zru zachycen chyby
      ENDIF
      IF !EMPTY(lcMessage)
         =m.loPDMs.WriteToLogFile(@m.lcMessage)
      ENDIF
      RETURN ""
   ENDPROC

   PROCEDURE GetSetting() &&  Return settings object
      RETURN CREATEOBJECT("_ac_base_par")
   ENDPROC

   PROCEDURE Open(lcFile,loSettings) && Load settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection,lcData,liCount,lii
      LOCAL ARRAY laPom(1)
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      * A te nati celou sekci jako data
      lcData=GetINISection(lcSection,32000,@m.lcFile) && Cel sekce
      lcData=STRTRAN(lcData,CHR(0),CHR(13)+CHR(10))
      lcCode=""
      liCount=ALINES(laPom,lcData) && Nati dky
      FOR lii=1 TO liCount
          lcCode=lcCode+SUBST(laPom(lii),2)+CHR(13)+CHR(10)
      NEXT
      m.loSettings.SourceCode=lcCode

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,loSettings) && Save settings
      * lcFile     - PDM File
      * loSettings - Object of settings

      LOCAL lcSection,lcData,liCount,lii
      LOCAL ARRAY laPom(1)

      lcSection="PI_"+LTRIM(STR(This.ID,11))
      lcData=""
      liCount=ALINES(laPom,m.loSettings.SourceCode) && Nati dky
      FOR lii=1 TO liCount
          lcData=lcData+"="+laPom(lii)+CHR(0)
      NEXT
      =WriteINISection(lcSection,@m.lcData,@m.lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst) && Clone values properties of settings
      * loSrc - Source object
      * loDst - Destination object
      loDst.SourceCode=loSrc.SourceCode
   ENDPROC


   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources() && Close other source
      RETURN .T.
   ENDPROC

   PROCEDURE InitResources(loSetting)
      * loSetting - Object of settings
      =DODEFAULT(@loSetting) && Voln pvodn metody
      RETURN .T.
   ENDPROC

ENDDEFINE

****************************************************************
DEFINE CLASS _ac_base_par AS _pdm_PlugIn_Parameter && Settings for plug-in
   Name="_ac_base_par"
   OK=.F.
 
   SourceCode=;
      "* How use this plugin"+CRLF+;
      "* loPDMs is local reference PDMs object"+CRLF+;
      "* loPDM is local reference PDM object - current PDM project at process"+CRLF+;
      ""+CRLF+;
      "loPDMs=EVAL(This.PDMs)"+CRLF+;
      "loPDM=EVAL(This.PDM)"+CRLF

   oPI=.NULL. && Object reference to plugin
ENDDEFINE

